diff --git a/tests/test_hub/test_build_image.py b/tests/test_hub/test_build_image.py
new file mode 100644
index 0000000..0f81fc6
--- /dev/null
+++ b/tests/test_hub/test_build_image.py
@@ -0,0 +1,69 @@
+import unittest
+import koji
+import kojihub
+import mock
+
+
+class TestBuildImage(unittest.TestCase):
+
+    def setUp(self):
+        self.context = mock.patch('kojihub.context').start()
+        self.exports = kojihub.RootExports()
+        self.context.session.assertPerm = mock.MagicMock()
+        self.context.session.hasPerm = mock.MagicMock()
+        self.make_task = mock.patch('kojihub.make_task').start()
+        self.mock_parse_arches = mock.patch('koji.parse_arches').start()
+        self.name = 'image-name'
+        self.version = 'test-version'
+        self.arch = 'x86_64'
+        self.target = 'test-target'
+        self.ksfile = 'test-ksfile'
+        self.image_type = 'livecd'
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_img_type_not_supported(self):
+        image_type = 'test-type'
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.buildImage(self.name, self.version, self.arch, self.target,
+                                    self.ksfile, image_type)
+        self.assertEqual(f"Unrecognized image type: {image_type}", str(cm.exception))
+
+    def test_name_wrong_type(self):
+        name = ['test-name']
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.buildImage(name, self.version, self.arch, self.target, self.ksfile,
+                                    self.image_type)
+        self.assertEqual(f"Invalid type for value '{name}': {type(name)}", str(cm.exception))
+
+    def test_version_wrong_type(self):
+        version = ['test-version']
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.buildImage(self.name, version, self.arch, self.target, self.ksfile,
+                                    self.image_type)
+        self.assertEqual(f"Invalid type for value '{version}': {type(version)}", str(cm.exception))
+
+    def test_ksfile_wrong_type(self):
+        ksfile = ['test-ksfile']
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.buildImage(self.name, self.version, self.arch, self.target, ksfile,
+                                    self.image_type)
+        self.assertEqual(f"Invalid type for value '{ksfile}': {type(ksfile)}", str(cm.exception))
+
+    def test_priority_without_admin(self):
+        priority = -10
+        image_type = 'livemedia'
+        self.context.session.assertPerm.side_effect = None
+        self.context.session.hasPerm.return_value = False
+        with self.assertRaises(koji.ActionNotAllowed) as cm:
+            self.exports.buildImage(self.name, self.version, self.arch, self.target, self.ksfile,
+                                    image_type, priority=priority)
+        self.assertEqual("only admins may create high-priority tasks", str(cm.exception))
+
+    def test_valid(self):
+        priority = 10
+        self.context.session.assertPerm.side_effect = None
+        self.make_task.return_value = 123
+        self.exports.buildImage(self.name, self.version, self.arch, self.target, self.ksfile,
+                                self.image_type, priority=priority)
diff --git a/tests/test_hub/test_build_image_indirection.py b/tests/test_hub/test_build_image_indirection.py
new file mode 100644
index 0000000..b963781
--- /dev/null
+++ b/tests/test_hub/test_build_image_indirection.py
@@ -0,0 +1,33 @@
+import unittest
+import koji
+import kojihub
+import mock
+
+
+class TestBuildImageIndirection(unittest.TestCase):
+
+    def setUp(self):
+        self.context = mock.patch('kojihub.context').start()
+        self.exports = kojihub.RootExports()
+        self.context.session.assertPerm = mock.MagicMock()
+        self.context.session.hasPerm = mock.MagicMock()
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_priority_without_admin(self):
+        priority = -10
+        self.context.session.assertPerm.side_effect = None
+        self.context.session.hasPerm.return_value = False
+        with self.assertRaises(koji.ActionNotAllowed) as cm:
+            self.exports.buildImageIndirection(priority=priority)
+        self.assertEqual("only admins may create high-priority tasks", str(cm.exception))
+
+    def test_opts_without_expected_keys(self):
+        priority = 10
+        opts = {}
+        self.context.session.assertPerm.side_effect = None
+        with self.assertRaises(koji.ActionNotAllowed) as cm:
+            self.exports.buildImageIndirection(opts=opts, priority=priority)
+        self.assertEqual("Non-scratch builds must provide url for the indirection template",
+                         str(cm.exception))
diff --git a/tests/test_hub/test_build_image_oz.py b/tests/test_hub/test_build_image_oz.py
new file mode 100644
index 0000000..aa5485b
--- /dev/null
+++ b/tests/test_hub/test_build_image_oz.py
@@ -0,0 +1,59 @@
+import unittest
+import koji
+import kojihub
+import mock
+
+
+class TestBuildImageOz(unittest.TestCase):
+
+    def setUp(self):
+        self.context = mock.patch('kojihub.context').start()
+        self.exports = kojihub.RootExports()
+        self.context.session.assertPerm = mock.MagicMock()
+        self.context.session.hasPerm = mock.MagicMock()
+        self.parse_arches = mock.patch('koji.parse_arches').start()
+        self.name = 'image-name'
+        self.version = 'test-version'
+        self.arches = ['x86_64', 'i386']
+        self.target = 'test-target'
+        self.inst_tree = 'test-tree'
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_name_wrong_type(self):
+        name = ['image-name']
+        with self.assertRaises(koji.ParameterError) as cm:
+            self.exports.buildImageOz(name, self.version, self.arches, self.target, self.inst_tree)
+        self.assertEqual(f"Invalid type for value '{name}': {type(name)}", str(cm.exception))
+
+    def test_inst_tree_wrong_type(self):
+        inst_tree = ['test-tree']
+        with self.assertRaises(koji.ParameterError) as cm:
+            self.exports.buildImageOz(self.name, self.version, self.arches, self.target, inst_tree)
+        self.assertEqual(f"Invalid type for value '{inst_tree}': {type(inst_tree)}",
+                         str(cm.exception))
+
+    def test_version_wrong_type(self):
+        version = ['test-version']
+        with self.assertRaises(koji.ParameterError) as cm:
+            self.exports.buildImageOz(self.name, version, self.arches, self.target, self.inst_tree)
+        self.assertEqual(f"Invalid type for value '{version}': {type(version)}", str(cm.exception))
+
+    def test_priority_without_admin(self):
+        priority = -10
+        self.context.session.assertPerm.side_effect = None
+        self.context.session.hasPerm.return_value = False
+        with self.assertRaises(koji.ActionNotAllowed) as cm:
+            self.exports.buildImageOz(self.name, self.version, self.arches, self.target,
+                                      self.inst_tree, priority=priority)
+        self.assertEqual("only admins may create high-priority tasks", str(cm.exception))
+
+    def test_opts_without_expected_keys(self):
+        priority = 10
+        opts = {}
+        self.context.session.assertPerm.side_effect = None
+        with self.assertRaises(koji.ActionNotAllowed) as cm:
+            self.exports.buildImageOz(self.name, self.version, self.arches, self.target,
+                                      self.inst_tree, opts=opts, priority=priority)
+        self.assertEqual("Non-scratch builds must provide ksurl", str(cm.exception))
diff --git a/tests/test_hub/test_cg_importer.py b/tests/test_hub/test_cg_importer.py
index 1717963..3f236e9 100644
--- a/tests/test_hub/test_cg_importer.py
+++ b/tests/test_hub/test_cg_importer.py
@@ -10,6 +10,7 @@ from koji import GenericError
 IP = kojihub.InsertProcessor
 UP = kojihub.UpdateProcessor
 
+
 class TestCGImporter(unittest.TestCase):
     TMP_PATH = os.path.join(os.path.dirname(__file__), 'tmptest')
 
@@ -36,7 +37,8 @@ class TestCGImporter(unittest.TestCase):
         metadata = 42
         with self.assertRaises(GenericError) as ex:
             x.get_metadata(metadata, '')
-        self.assertEqual('Invalid type for metadata value: %s' % type(metadata), str(ex.exception))
+        self.assertEqual(f"Invalid type for value '{metadata}': {type(metadata)}",
+                         str(ex.exception))
 
     def test_get_metadata_is_none(self):
         x = kojihub.CG_Importer()
@@ -158,7 +160,7 @@ class TestCGImporter(unittest.TestCase):
                                   'start_time': None, 'start_ts': None,
                                   'completion_time': None, 'completion_ts': None,
                                   'source': 'https://example.com', 'extra': {}
-                                 }
+                                  }
         new_build_id.return_value = 43
         x.get_build()
         assert x.buildinfo
@@ -187,7 +189,7 @@ class TestCGImporter(unittest.TestCase):
         get_metadata.return_value = metadata
         with self.assertRaises(koji.GenericError) as ex:
             x.do_import(metadata, '/test/dir')
-        self.assertEqual('No such metadata version: %s' % metadata['metadata_version'],
+        self.assertEqual(f"No such metadata version: {metadata['metadata_version']}",
                          str(ex.exception))
 
     def test_match_componemt_wrong_component(self):
@@ -195,7 +197,7 @@ class TestCGImporter(unittest.TestCase):
         components = [{'type': 'type'}]
         with self.assertRaises(koji.GenericError) as ex:
             x.match_components(components)
-        self.assertEqual('No such component type: %s' % components[0]['type'], str(ex.exception))
+        self.assertEqual(f"No such component type: {components[0]['type']}", str(ex.exception))
 
 
 class TestMatchKojiFile(unittest.TestCase):
@@ -203,23 +205,23 @@ class TestMatchKojiFile(unittest.TestCase):
     def setUp(self):
         self.importer = kojihub.CG_Importer()
         self.archive1 = {
-                'id': 99,
-                'build_id': 42,
-                'checksum': 'e1f95555eae04b8e1ebdc5555c5555f0',
-                'checksum_type': 0,
-                'filename': 'foo-bar-3.0.jar',
-                'size': 42710,
-                }
+            'id': 99,
+            'build_id': 42,
+            'checksum': 'e1f95555eae04b8e1ebdc5555c5555f0',
+            'checksum_type': 0,
+            'filename': 'foo-bar-3.0.jar',
+            'size': 42710,
+        }
         self.build1 = {
-                'id': 79218,
-                'nvr': 'foo-3.0-1',
-                }
+            'id': 79218,
+            'nvr': 'foo-3.0-1',
+        }
         self.comp1 = {
-                'type': 'kojifile',
-                'archive_id': self.archive1['id'],
-                'nvr': self.build1['nvr'],
-                'filename': self.archive1['filename'],
-                }
+            'type': 'kojifile',
+            'archive_id': self.archive1['id'],
+            'nvr': self.build1['nvr'],
+            'filename': self.archive1['filename'],
+        }
         self.get_archive = mock.patch('kojihub.get_archive').start()
         self.get_build = mock.patch('kojihub.get_build').start()
 
@@ -270,7 +272,6 @@ class TestCGReservation(unittest.TestCase):
         self.updates.append(update)
         return update
 
-
     def setUp(self):
         self.InsertProcessor = mock.patch('kojihub.InsertProcessor',
                                           side_effect=self.getInsert).start()
@@ -298,8 +299,8 @@ class TestCGReservation(unittest.TestCase):
         new_build.return_value = 654
         cg = 'content_generator_name'
         self.mock_cursor.fetchone.side_effect = [
-            [333], # get pkg_id
-            [1234], # get nextval pkg_id
+            [333],  # get pkg_id
+            [1234],  # get nextval pkg_id
         ]
         self.mock_cursor.fetchall.side_effect = [
             [[]],
diff --git a/tests/test_hub/test_chain_build.py b/tests/test_hub/test_chain_build.py
new file mode 100644
index 0000000..42ae5fe
--- /dev/null
+++ b/tests/test_hub/test_chain_build.py
@@ -0,0 +1,40 @@
+import unittest
+import koji
+import kojihub
+import mock
+
+
+class TestChainBuild(unittest.TestCase):
+
+    def setUp(self):
+        self.context = mock.patch('kojihub.context').start()
+        self.exports = kojihub.RootExports()
+        self.context.session.assertLogin = mock.MagicMock()
+        self.context.session.hasPerm = mock.MagicMock()
+        self.get_channel = mock.patch('kojihub.get_channel').start()
+        self.make_task = mock.patch('kojihub.make_task').start()
+        self.srcs = ['pkg1']
+        self.target = 'test-target'
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_srcs_wrong_type(self):
+        srcs = 'pkg'
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.chainBuild(srcs, self.target)
+        self.assertEqual(f"Invalid type for value '{srcs}': {type(srcs)}", str(cm.exception))
+
+    def test_priority_without_admin(self):
+        priority = -10
+        self.context.session.hasPerm.return_value = False
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.chainBuild(self.srcs, self.target, priority=priority)
+        self.assertEqual("only admins may create high-priority tasks", str(cm.exception))
+
+    def test_channel_not_str(self):
+        priority = 10
+        self.get_channel.return_value = {'comment': None, 'description': None, 'enabled': True,
+                                         'id': 2, 'name': 'maven'}
+        self.make_task.return_value = 123
+        self.exports.chainBuild(self.srcs, self.target, priority=priority, channel=2)
diff --git a/tests/test_hub/test_chain_maven.py b/tests/test_hub/test_chain_maven.py
new file mode 100644
index 0000000..f5b737d
--- /dev/null
+++ b/tests/test_hub/test_chain_maven.py
@@ -0,0 +1,48 @@
+import unittest
+import koji
+import kojihub
+import mock
+
+
+class TestChainMaven(unittest.TestCase):
+
+    def setUp(self):
+        self.context = mock.patch('kojihub.context').start()
+        self.exports = kojihub.RootExports()
+        self.context.session.assertLogin = mock.MagicMock()
+        self.context.session.hasPerm = mock.MagicMock()
+        self.get_channel = mock.patch('kojihub.get_channel').start()
+        self.make_task = mock.patch('kojihub.make_task').start()
+        self.builds = ['build1', 'build2', 'build3']
+        self.target = 'test-target'
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_maven_not_supported(self):
+        self.context.opts.get.return_value = False
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.chainMaven(self.builds, self.target)
+        self.assertEqual("Maven support not enabled", str(cm.exception))
+
+    def test_builds_wrong_type(self):
+        builds = 'test-builds'
+        self.context.opts.get.return_value = True
+        with self.assertRaises(koji.ParameterError) as cm:
+            self.exports.chainMaven(builds, self.target)
+        self.assertEqual(f"Invalid type for value '{builds}': {type(builds)}", str(cm.exception))
+
+    def test_priority_without_admin(self):
+        priority = -10
+        self.context.opts.get.return_value = True
+        self.context.session.hasPerm.return_value = False
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.chainMaven(self.builds, self.target, priority=priority)
+        self.assertEqual("only admins may create high-priority tasks", str(cm.exception))
+
+    def test_channel_not_str(self):
+        self.context.opts.get.return_value = True
+        self.make_task.return_value = 123
+        self.get_channel.return_value = {'comment': None, 'description': None, 'enabled': True,
+                                         'id': 2, 'name': 'maven'}
+        self.exports.chainMaven(self.builds, self.target, channel=2, priority=10)
diff --git a/tests/test_hub/test_create_notification.py b/tests/test_hub/test_create_notification.py
index e3ff819..7b0dacf 100644
--- a/tests/test_hub/test_create_notification.py
+++ b/tests/test_hub/test_create_notification.py
@@ -4,57 +4,168 @@ import mock
 import koji
 import kojihub
 
+QP = kojihub.QueryProcessor
+IP = kojihub.InsertProcessor
+UP = kojihub.UpdateProcessor
+
 
 class TestCreateNotification(unittest.TestCase):
+    def getInsert(self, *args, **kwargs):
+        insert = IP(*args, **kwargs)
+        insert.execute = mock.MagicMock()
+        self.inserts.append(insert)
+        return insert
+
+    def getQuery(self, *args, **kwargs):
+        query = QP(*args, **kwargs)
+        query.execute = mock.MagicMock()
+        self.queries.append(query)
+        return query
+
+    def getUpdate(self, *args, **kwargs):
+        update = UP(*args, **kwargs)
+        update.execute = mock.MagicMock()
+        self.updates.append(update)
+        return update
 
     def setUp(self):
+        self.context = mock.patch('kojihub.context').start()
+        self.context.opts = {
+            'EmailDomain': 'test.domain.com',
+            'NotifyOnSuccess': True,
+        }
+        self.QueryProcessor = mock.patch('kojihub.QueryProcessor',
+                                         side_effect=self.getQuery).start()
+        self.queries = []
+        self.InsertProcessor = mock.patch('kojihub.InsertProcessor',
+                                          side_effect=self.getInsert).start()
+        self.inserts = []
+        self.UpdateProcessor = mock.patch('kojihub.UpdateProcessor',
+                                          side_effect=self.getUpdate).start()
+        self.updates = []
+        self.get_build_notifications = mock.patch('kojihub.get_build_notifications').start()
+        self.get_tag_id = mock.patch('kojihub.get_tag_id').start()
+        self.get_package_id = mock.patch('kojihub.get_package_id').start()
+
         self.exports = kojihub.RootExports()
         self.exports.getLoggedInUser = mock.MagicMock()
-        self.context = mock.patch('kojihub.context').start()
+        self.exports.getUser = mock.MagicMock()
+        self.exports.hasPerm = mock.MagicMock()
         self.cursor = mock.MagicMock()
+        self.user_id = 1
+        self.package_id = 345
+        self.tag_id = 345
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_createNotification(self):
+        success_only = True
+        self.exports.getLoggedInUser.return_value = {'id': 1}
+        self.exports.getUser.return_value = {'id': 2, 'name': 'username'}
+        self.exports.hasPerm.return_value = True
+        self.get_package_id.return_value = self.package_id
+        self.get_tag_id.return_value = self.tag_id
+        self.get_build_notifications.return_value = []
+
+        r = self.exports.createNotification(
+            self.user_id, self.package_id, self.tag_id, success_only)
+        self.assertEqual(r, None)
+
+        self.exports.getLoggedInUser.assert_called_once()
+        self.exports.getUser.asssert_called_once_with(self.user_id)
+        self.exports.hasPerm.asssert_called_once_with('admin')
+        self.get_package_id.assert_called_once_with(self.package_id, strict=True)
+        self.get_tag_id.assert_called_once_with(self.tag_id, strict=True)
+        self.get_build_notifications.assert_called_once_with(2)
+        self.assertEqual(len(self.inserts), 1)
+        insert = self.inserts[0]
+        self.assertEqual(insert.table, 'build_notifications')
+        self.assertEqual(insert.data, {
+            'package_id': self.package_id,
+            'user_id': 2,
+            'tag_id': self.tag_id,
+            'success_only': success_only,
+            'email': 'username@test.domain.com',
+        })
+        self.assertEqual(insert.rawdata, {})
+
+    def test_createNotification_unauthentized(self):
+        success_only = True
+        self.exports.getLoggedInUser.return_value = None
 
-    def test_non_exist_user(self):
-        user_id = 999
-        package_id = 555
-        tag_id = 111
-        success_only = False
-        logged_user = {'authtype': 2,
-                       'id': 1,
-                       'krb_principal': None,
-                       'krb_principals': [],
-                       'name': 'kojiadmin',
-                       'status': 0,
-                       'usertype': 0}
-        self.cursor.fetchone.return_value = None
-        self.context.cnx.cursor.return_value = self.cursor
-        self.exports.getLoggedInUser.return_value = logged_user
         with self.assertRaises(koji.GenericError) as cm:
-            self.exports.createNotification(user_id, package_id, tag_id, success_only)
-        self.assertEqual('No such user ID: %s' % user_id, str(cm.exception))
+            self.exports.createNotification(
+                self.user_id, self.package_id, self.tag_id, success_only)
+        self.assertEqual('Not logged-in', str(cm.exception))
 
+        self.assertEqual(len(self.inserts), 0)
 
-class TestCreateNotificationBlock(unittest.TestCase):
+    def test_createNotification_invalid_user(self):
+        user_id = 2
+        success_only = True
+        self.exports.getLoggedInUser.return_value = {'id': 1}
+        self.exports.getUser.return_value = None
 
-    def setUp(self):
-        self.exports = kojihub.RootExports()
-        self.exports.getLoggedInUser = mock.MagicMock()
-        self.context = mock.patch('kojihub.context').start()
-        self.cursor = mock.MagicMock()
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.createNotification(user_id, self.package_id, self.tag_id, success_only)
+        self.assertEqual(f'No such user ID: {user_id}', str(cm.exception))
+
+        self.assertEqual(len(self.inserts), 0)
+
+    def test_createNotification_no_perm(self):
+        user_id = 2
+        success_only = True
+        self.exports.getLoggedInUser.return_value = {'id': 1, 'name': 'a'}
+        self.exports.getUser.return_value = {'id': 2, 'name': 'b'}
+        self.exports.hasPerm.return_value = False
 
-    def test_non_exist_user(self):
-        user_id = 999
-        package_id = 555
-        tag_id = 111
-        logged_user = {'authtype': 2,
-                       'id': 1,
-                       'krb_principal': None,
-                       'krb_principals': [],
-                       'name': 'kojiadmin',
-                       'status': 0,
-                       'usertype': 0}
-        self.cursor.fetchone.return_value = None
-        self.context.cnx.cursor.return_value = self.cursor
-        self.exports.getLoggedInUser.return_value = logged_user
         with self.assertRaises(koji.GenericError) as cm:
-            self.exports.createNotificationBlock(user_id, package_id, tag_id)
-        self.assertEqual('No such user ID: %s' % user_id, str(cm.exception))
+            self.exports.createNotification(user_id, self.package_id, self.tag_id, success_only)
+        self.assertEqual('user a cannot create notifications for user b', str(cm.exception))
+
+        self.assertEqual(len(self.inserts), 0)
+
+    def test_createNotification_invalid_pkg(self):
+        user_id = 2
+        success_only = True
+        self.exports.getLoggedInUser.return_value = {'id': 2, 'name': 'a'}
+        self.exports.getUser.return_value = {'id': 2, 'name': 'a'}
+        self.get_package_id.side_effect = ValueError
+
+        with self.assertRaises(ValueError):
+            self.exports.createNotification(user_id, self.package_id, self.tag_id, success_only)
+
+        self.assertEqual(len(self.inserts), 0)
+
+    def test_createNotification_invalid_tag(self):
+        user_id = 2
+        success_only = True
+        self.exports.getLoggedInUser.return_value = {'id': 2, 'name': 'a'}
+        self.exports.getUser.return_value = {'id': 2, 'name': 'a'}
+        self.get_package_id.return_value = self.package_id
+        self.get_tag_id.side_effect = ValueError
+
+        with self.assertRaises(ValueError):
+            self.exports.createNotification(user_id, self.package_id, self.tag_id, success_only)
+
+        self.assertEqual(len(self.inserts), 0)
+
+    def test_createNotification_exists(self):
+        user_id = 2
+        success_only = True
+        self.exports.getLoggedInUser.return_value = {'id': 2, 'name': 'a'}
+        self.exports.getUser.return_value = {'id': 2, 'name': 'a'}
+        self.get_package_id.return_value = self.package_id
+        self.get_tag_id.return_value = self.tag_id
+        self.get_build_notifications.return_value = [{
+            'package_id': self.package_id,
+            'tag_id': self.tag_id,
+            'success_only': success_only,
+        }]
+
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.createNotification(user_id, self.package_id, self.tag_id, success_only)
+        self.assertEqual('notification already exists', str(cm.exception))
+
+        self.assertEqual(len(self.inserts), 0)
